/**
  ******************************************************************************
  * @file    clock_res.c
  * @author  MCD Application Team
  * @version V1.0.0
  * @date    20-September-2013 
  * @brief   Clock resources
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2013 STMicroelectronics</center></h2>
  *
  * Licensed under MCD-ST Liberty SW License Agreement V2, (the "License");
  * You may not use this file except in compliance with the License.
  * You may obtain a copy of the License at:
  *
  *        http://www.st.com/software_license_agreement_liberty_v2
  *
  * Unless required by applicable law or agreed to in writing, software 
  * distributed under the License is distributed on an "AS IS" BASIS, 
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
  *
  ******************************************************************************
  */

#include <stdlib.h>

#include "GUI.h"

#ifndef GUI_CONST_STORAGE
  #define GUI_CONST_STORAGE const
#endif

extern GUI_CONST_STORAGE GUI_BITMAP _bmArrowRight;
extern GUI_CONST_STORAGE GUI_BITMAP _bmArrowLeft;
extern GUI_CONST_STORAGE GUI_FONT GUI_FontBauhaus9332;

/* Bitmap data for arrow keys */
static GUI_CONST_STORAGE GUI_COLOR _aColorsArrow[] = {
  0xFFFFFF, 0x000000
};

static GUI_CONST_STORAGE GUI_LOGPALETTE _PalArrow = {
  2,	/* number of entries */
  1, 	/* No transparency */
  &_aColorsArrow[0]
};

static GUI_CONST_STORAGE unsigned char _acArrowRight[] = {
  ____XX__, ________,
  ____XXXX, ________,
  XXXXXXXX, XX______,
  ____XXXX, ________,
  ____XX__, ________
};

static GUI_CONST_STORAGE unsigned char _acArrowLeft[] = {
  ____XX__, ________,
  __XXXX__, ________,
  XXXXXXXX, XX______,
  __XXXX__, ________,
  ____XX__, ________
};

GUI_CONST_STORAGE GUI_BITMAP _bmArrowRight = {
  10,           /* XSize */
  5,            /* YSize */
  2,            /* BytesPerLine */
  1,            /* BitsPerPixel */
  _acArrowRight, /* Pointer to picture data (indices) */
  &_PalArrow     /* Pointer to palette */
};

GUI_CONST_STORAGE GUI_BITMAP _bmArrowLeft = {
  10,           /* XSize */
  5,            /* YSize */
  2,            /* BytesPerLine */
  1,            /* BitsPerPixel */
  _acArrowLeft,  /* Pointer to picture data (indices) */
  &_PalArrow     /* Pointer to palette */
};

/* Start of unicode area <Basic Latin> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0020[128] = { /* code 0020, SPACE */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0021[224] = { /* code 0021, EXCLAMATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0022[256] = { /* code 0022, QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x01, 0xCF, 0xFF, 0xF9, 0xDF, 0xFF, 0xF5, 0x00,
  0x00, 0xAF, 0xFF, 0xF6, 0xCF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xE3, 0xAF, 0xFF, 0xD2, 0x00,
  0x00, 0x5F, 0xFF, 0xD2, 0x7F, 0xFF, 0xC1, 0x00,
  0x00, 0x3E, 0xFF, 0xC1, 0x5F, 0xFF, 0xA0, 0x00,
  0x00, 0x2D, 0xFF, 0xA0, 0x3E, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0023[320] = { /* code 0023, NUMBER SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0x75, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFE, 0x35, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFD, 0x27, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFD, 0x2A, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFC, 0x2C, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x2D, 0xFF, 0xD2, 0x3E, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xD2, 0x5F, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xC1, 0x7F, 0xFF, 0xA0, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x01, 0xCF, 0xFE, 0x32, 0xDF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFE, 0x33, 0xEF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFD, 0x25, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x15, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFA, 0x0A, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0024[288] = { /* code 0024, DOLLAR SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0025[448] = { /* code 0025, PERCENT SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFD, 0x20, 0x00, 0x05, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x1C, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x3E, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0x50, 0xAF, 0xFF, 0x70, 0x7F, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFA, 0x00, 0x2D, 0xFF, 0xA2, 0xDF, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFA, 0x00, 0x2D, 0xFF, 0xC6, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0x50, 0xAF, 0xFF, 0x7A, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xF5, 0x7F, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFD, 0x22, 0xDF, 0xA0, 0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x0A, 0xFC, 0x1A, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0xF7, 0x3E, 0xFF, 0xE3, 0x1C, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xE3, 0x5F, 0xFF, 0x70, 0x03, 0xEF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xA0, 0x5F, 0xFF, 0x70, 0x03, 0xEF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x05, 0xFF, 0x50, 0x3E, 0xFF, 0xE3, 0x1C, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x0A, 0xFD, 0x20, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x3E, 0xF7, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xE3, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0026[384] = { /* code 0026, AMPERSAND */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFD, 0x6F, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xCC, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0027[128] = { /* code 0027, APOSTROPHE */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xD2,
  0x0A, 0xFF, 0xFF, 0xA0,
  0x0A, 0xFF, 0xFF, 0xA0,
  0x07, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFE, 0x30,
  0x02, 0xDF, 0xFD, 0x20,
  0x02, 0xDF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0028[192] = { /* code 0028, LEFT PARENTHESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x7F, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xE3, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x3E, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x7F, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0xAF, 0xFF, 0xFC, 0x10, 0x00,
  0x01, 0xCF, 0xFF, 0xFA, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xF7, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xF7, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xF7, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xF7, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xF7, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x3E, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0029[192] = { /* code 0029, RIGHT PARENTHESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xC1, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xF5, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xF5, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xF5, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xE3, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00,
  0x01, 0xCF, 0xFF, 0xF5, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xC1, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_002A[256] = { /* code 002A, ASTERISK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x02, 0x31, 0x00, 0x3D, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_002B[352] = { /* code 002B, PLUS SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_002C[192] = { /* code 002C, COMMA */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xC1, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x1C, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_002D[128] = { /* code 002D, HYPHEN-MINUS */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0xCF, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xF0,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_002E[192] = { /* code 002E, FULL STOP */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_002F[192] = { /* code 002F, SOLIDUS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xF5, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x5F, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x7F, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0xAF, 0xFA, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xF7, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xF5, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x5F, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x7F, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0xAF, 0xFC, 0x10, 0x00, 0x00,
  0x02, 0xDF, 0xF7, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xF5, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0030[288] = { /* code 0030, DIGIT ZERO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFC, 0x10,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0031[288] = { /* code 0031, DIGIT ONE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0032[288] = { /* code 0032, DIGIT TWO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x07, 0xFF, 0xFF, 0xFC, 0x2C, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xF7, 0x0A, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xFC, 0x4E, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xF5, 0xAF, 0xFF, 0xFF, 0xF7, 0x00,
  0x01, 0xCF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x5F, 0xFF, 0x6C, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x05, 0xFC, 0x6F, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0033[288] = { /* code 0033, DIGIT THREE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x02, 0x31, 0xAF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x25, 0x30, 0x5F, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0034[288] = { /* code 0034, DIGIT FOUR */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x03, 0xEF, 0xFF, 0xFB, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x07, 0xFF, 0xFF, 0xE5, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x7F, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFE, 0x30,
  0x0A, 0xFF, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFE, 0x30,
  0x13, 0x20, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0035[288] = { /* code 0035, DIGIT FIVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x33, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0036[288] = { /* code 0036, DIGIT SIX */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x13, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFD, 0x8B, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xF5, 0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xE3, 0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFC, 0x17, 0xFF, 0xFF, 0xFF, 0x50,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0037[288] = { /* code 0037, DIGIT SEVEN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0038[288] = { /* code 0038, DIGIT EIGHT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x7F, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x7F, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xD2, 0x00,
  0x00, 0x5F, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFC, 0x10,
  0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x7F, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x7F, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFA, 0x03, 0xEF, 0xFF, 0xFA, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0039[288] = { /* code 0039, DIGIT NINE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xF5, 0x01, 0xCF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFA, 0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x0A, 0xFF, 0xFF, 0xFF, 0xDB, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x03, 0xEF, 0xFC, 0xCF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x01, 0x33, 0xDF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_003A[192] = { /* code 003A, COLON */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_003B[192] = { /* code 003B, SEMICOLON */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x1C, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_003C[256] = { /* code 003C, LESS-THAN SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x1C, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xED, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_003D[352] = { /* code 003D, EQUALS SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_003E[256] = { /* code 003E, GREATER-THAN SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x13, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_003F[256] = { /* code 003F, QUESTION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xE3, 0x3E, 0xFF, 0xFF, 0xD2,
  0x00, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xD2,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0040[352] = { /* code 0040, COMMERCIAL AT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xD2, 0x00, 0x02, 0xDF, 0xFF, 0xA0, 0x00,
  0x00, 0x1C, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x05, 0xFF, 0xF7, 0x00,
  0x00, 0x7F, 0xFE, 0x30, 0x05, 0xFF, 0xFF, 0xE3, 0x5F, 0xFE, 0x30,
  0x02, 0xDF, 0xF7, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0x5A, 0xFF, 0x70,
  0x07, 0xFF, 0xD2, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xA5, 0xFF, 0xC1,
  0x0A, 0xFF, 0xA0, 0x7F, 0xFF, 0xE4, 0xCF, 0xFF, 0xC6, 0xFF, 0xC1,
  0x1C, 0xFF, 0x71, 0xCF, 0xFF, 0xA0, 0xAF, 0xFF, 0xA5, 0xFF, 0xC1,
  0x2D, 0xFF, 0x52, 0xDF, 0xFF, 0x71, 0xCF, 0xFF, 0x77, 0xFF, 0xA0,
  0x1C, 0xFF, 0x53, 0xEF, 0xFF, 0xFF, 0xFF, 0xFE, 0x4C, 0xFF, 0x70,
  0x1C, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xFF, 0xFD, 0x9F, 0xFC, 0x10,
  0x07, 0xFF, 0xC1, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xF5, 0x1C, 0xFF, 0xA0, 0xAF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xD2, 0x00, 0x00, 0x07, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0041[288] = { /* code 0041, LATIN CAPITAL LETTER A */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0042[288] = { /* code 0042, LATIN CAPITAL LETTER B */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x02, 0xDF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFD, 0x20,
  0x02, 0xDF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x2D, 0xFF, 0xFF, 0xD0,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x2D, 0xFF, 0xFF, 0xD0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0043[352] = { /* code 0043, LATIN CAPITAL LETTER C */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x32,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD2,
  0x1C, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0x50,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0044[352] = { /* code 0044, LATIN CAPITAL LETTER D */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF5,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF7,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF7,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xF7,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF5,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xD2,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0045[256] = { /* code 0045, LATIN CAPITAL LETTER E */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0046[256] = { /* code 0046, LATIN CAPITAL LETTER F */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x56, 0x72, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0047[288] = { /* code 0047, LATIN CAPITAL LETTER G */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x27, 0x60, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x5F, 0xFF, 0xFF, 0xF7, 0x02, 0xDF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xF7, 0x02, 0xDF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFC, 0x12, 0xDF, 0xFF, 0xFF, 0xFC,
  0x1C, 0xFF, 0xFF, 0xFF, 0x52, 0xDF, 0xFF, 0xFF, 0xFD,
  0x05, 0xFF, 0xFF, 0xFF, 0xFA, 0x01, 0xCF, 0xFF, 0xFD,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0048[288] = { /* code 0048, LATIN CAPITAL LETTER H */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0049[160] = { /* code 0049, LATIN CAPITAL LETTER I */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_004A[160] = { /* code 004A, LATIN CAPITAL LETTER J */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x01, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0,
  0xEF, 0xFF, 0xFF, 0xFF, 0x70,
  0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0xEF, 0xFF, 0xFF, 0xFA, 0x00,
  0xEF, 0xFF, 0xFF, 0xA0, 0x00,
  0xEF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_004B[320] = { /* code 004B, LATIN CAPITAL LETTER K */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x01, 0xCF, 0xFF, 0xFF, 0xD0,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x2D, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0xAF, 0xFF, 0xFF, 0xD2, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x73, 0xEF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x8C, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x8C, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x75, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xD2, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x7F, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x3E, 0xFF, 0xFF, 0xFC, 0x10,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x1C, 0xFF, 0xFF, 0xFF, 0x50,
  0x02, 0xDF, 0xFF, 0xFF, 0x70, 0x05, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_004C[160] = { /* code 004C, LATIN CAPITAL LETTER L */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF,
  0x00, 0x07, 0xFF, 0xFF, 0xFF,
  0x00, 0x00, 0x1C, 0xFF, 0xFF,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_004D[384] = { /* code 004D, LATIN CAPITAL LETTER M */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xA0, 0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFB, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_004E[288] = { /* code 004E, LATIN CAPITAL LETTER N */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_004F[352] = { /* code 004F, LATIN CAPITAL LETTER O */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0050[288] = { /* code 0050, LATIN CAPITAL LETTER P */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x72, 0xDF, 0xFF, 0xFF, 0xC0,
  0x05, 0xFF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xC0,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0051[352] = { /* code 0051, LATIN CAPITAL LETTER Q */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x5F, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFC, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0052[288] = { /* code 0052, LATIN CAPITAL LETTER R */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x7F, 0xFF, 0xFF, 0xF7,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x2D, 0xFF, 0xFF, 0xFA,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x7F, 0xFF, 0xFF, 0xF7,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xBD, 0xFF, 0xFF, 0xFD, 0x20,
  0x02, 0xDF, 0xFF, 0xFF, 0xAA, 0xFF, 0xFF, 0xFF, 0x50,
  0x02, 0xDF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0xAF, 0xFF, 0xFF, 0xE3,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x5F, 0xFF, 0xFF, 0xFC,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0053[224] = { /* code 0053, LATIN CAPITAL LETTER S */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3, 0x00,
  0x13, 0x25, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0054[256] = { /* code 0054, LATIN CAPITAL LETTER T */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0055[288] = { /* code 0055, LATIN CAPITAL LETTER U */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0056[256] = { /* code 0056, LATIN CAPITAL LETTER V */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFF, 0xFF, 0xA0, 0x2D, 0xFF, 0xFF, 0xFF,
  0xFF, 0xFF, 0xFF, 0xD2, 0x5F, 0xFF, 0xFF, 0xFA,
  0xCF, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xF9, 0xDF, 0xFF, 0xFF, 0xC1,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x25, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0057[384] = { /* code 0057, LATIN CAPITAL LETTER W */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFE, 0x5D, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFB, 0xDF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xA0, 0x03, 0xEF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0058[256] = { /* code 0058, LATIN CAPITAL LETTER X */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFF, 0xFF, 0x50, 0x3E, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xC1, 0x7F, 0xFF, 0xFF, 0xD0,
  0x5F, 0xFF, 0xFF, 0xF9, 0xDF, 0xFF, 0xFF, 0x50,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0xAF, 0xFF, 0xFF, 0xC4, 0xEF, 0xFF, 0xFF, 0xA0,
  0xEF, 0xFF, 0xFF, 0x70, 0xAF, 0xFF, 0xFF, 0xE0,
  0xFF, 0xFF, 0xFD, 0x20, 0x3E, 0xFF, 0xFF, 0xF0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0059[256] = { /* code 0059, LATIN CAPITAL LETTER Y */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFF, 0xFD, 0x20, 0x0A, 0xFF, 0xFF, 0xF0,
  0xDF, 0xFF, 0xFF, 0xA0, 0x5F, 0xFF, 0xFF, 0xF0,
  0x5F, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFF, 0xA0,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_005A[256] = { /* code 005A, LATIN CAPITAL LETTER Z */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_005B[192] = { /* code 005B, LEFT SQUARE BRACKET */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_005C[192] = { /* code 005C, REVERSE SOLIDUS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xF5, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0xAF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x7F, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xF5, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x7F, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x5F, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xF5, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xF7, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_005D[192] = { /* code 005D, RIGHT SQUARE BRACKET */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_005E[256] = { /* code 005E, CIRCUMFLEX ACCENT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xD3, 0xDF, 0xFF, 0xE3, 0x00,
  0x0A, 0xFF, 0xFF, 0xA0, 0xAF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFE, 0x30, 0x3E, 0xFF, 0xFE, 0x30,
  0xCF, 0xFF, 0xFC, 0x10, 0x1C, 0xFF, 0xFF, 0xC0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_005F[256] = { /* code 005F, LOW LINE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD0,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD0,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0060[256] = { /* code 0060, GRAVE ACCENT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0061[288] = { /* code 0061, LATIN SMALL LETTER A */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0062[288] = { /* code 0062, LATIN SMALL LETTER B */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFE, 0x33, 0xEF, 0xFF, 0xFF, 0x70,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x0A, 0xFF, 0xFF, 0xF7, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x07, 0xFF, 0xFF, 0xFD, 0x23, 0xEF, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0063[288] = { /* code 0063, LATIN SMALL LETTER C */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x0A, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x1C, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFC, 0x1A, 0xFF, 0xFF, 0xFC, 0x10,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0064[288] = { /* code 0064, LATIN SMALL LETTER D */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFA, 0x13, 0xDF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xD2, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xD2, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFA, 0x0A, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0065[288] = { /* code 0065, LATIN SMALL LETTER E */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xF7, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x39, 0x91, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x33, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0066[192] = { /* code 0066, LATIN SMALL LETTER F */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFE, 0x30,
  0x00, 0x00, 0x5F, 0xFF, 0xFE, 0x30,
  0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x3E, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0xAF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x03, 0xEF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0067[288] = { /* code 0067, LATIN SMALL LETTER G */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x0A, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xF7, 0x6E, 0xFF, 0xFF, 0xFC, 0x10,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0068[256] = { /* code 0068, LATIN SMALL LETTER H */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0069[160] = { /* code 0069, LATIN SMALL LETTER I */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xA0, 0x00,
  0x03, 0xEF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_006A[192] = { /* code 006A, LATIN SMALL LETTER J */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0x50, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xF5, 0x00,
  0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_006B[256] = { /* code 006B, LATIN SMALL LETTER K */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xF7,
  0x05, 0xFF, 0xFF, 0xFA, 0xAF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFB, 0xDF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFB, 0xDF, 0xFF, 0xFF, 0x50,
  0x05, 0xFF, 0xFF, 0xFA, 0x7F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFA,
  0x05, 0xFF, 0xFF, 0xFA, 0x07, 0xFF, 0xFF, 0xFD,
  0x05, 0xFF, 0xFF, 0xFA, 0x03, 0xEF, 0xFF, 0xFF,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_006C[160] = { /* code 006C, LATIN SMALL LETTER L */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_006D[384] = { /* code 006D, LATIN SMALL LETTER M */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x70, 0x1C, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x05, 0xFF, 0xFF, 0xFD, 0x9F, 0xFF, 0xFF, 0xD9, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_006E[256] = { /* code 006E, LATIN SMALL LETTER N */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_006F[288] = { /* code 006F, LATIN SMALL LETTER O */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0070[288] = { /* code 0070, LATIN SMALL LETTER P */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFD, 0x23, 0xEF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xF7, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x1C, 0xFF, 0xFF, 0xFE, 0x35, 0xFF, 0xFF, 0xFF, 0x70,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0071[288] = { /* code 0071, LATIN SMALL LETTER Q */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x0A, 0xFF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xD2, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xD2, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFA, 0x13, 0xDF, 0xFF, 0xFE, 0x30,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0072[160] = { /* code 0072, LATIN SMALL LETTER R */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFD,
  0x00, 0x07, 0xFF, 0xFF, 0xFD,
  0x00, 0x5F, 0xFF, 0xFF, 0xFD,
  0x01, 0xCF, 0xFF, 0xFF, 0xFD,
  0x03, 0xEF, 0xFF, 0xFF, 0xFD,
  0x05, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0073[192] = { /* code 0073, LATIN SMALL LETTER S */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xD0,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD0,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x3E, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0xCF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0xCF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0xCF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0074[160] = { /* code 0074, LATIN SMALL LETTER T */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00,
  0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x0A, 0xFF, 0xFF, 0xFF, 0xF7,
  0x03, 0xEF, 0xFF, 0xFF, 0xF7,
  0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x00, 0x07, 0xFF, 0xFF, 0xF7,
  0x00, 0x00, 0x1C, 0xFF, 0xF7,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0075[256] = { /* code 0075, LATIN SMALL LETTER U */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0076[192] = { /* code 0076, LATIN SMALL LETTER V */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFF, 0xE3, 0x3E, 0xFF, 0xFF,
  0xFF, 0xFF, 0xF7, 0xAF, 0xFF, 0xFD,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA,
  0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0xAF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x05, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x02, 0xDF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x13, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0077[384] = { /* code 0077, LATIN SMALL LETTER W */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x70, 0x3E, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0078[256] = { /* code 0078, LATIN SMALL LETTER X */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x07, 0xFF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0xD2,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0079[256] = { /* code 0079, LATIN SMALL LETTER Y */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x7F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xA0,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_007A[256] = { /* code 007A, LATIN SMALL LETTER Z */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_007B[192] = { /* code 007B, LEFT CURLY BRACKET */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0x50,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x01, 0xCF, 0xFF, 0xFC, 0x10, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0xAF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFE, 0x43, 0x20,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_007C[256] = { /* code 007C, VERTICAL LINE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_007D[192] = { /* code 007D, RIGHT CURLY BRACKET */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0x50,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x50,
  0x00, 0x05, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xD2, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_007E[320] = { /* code 007E, TILDE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xA0, 0x06, 0x72, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x03, 0xEF, 0xA0, 0x1C, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Latin-1 Supplement> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A0[128] = { /* code 00A0, NO-BREAK SPACE */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A1[224] = { /* code 00A1, INVERTED EXCLAMATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A2[288] = { /* code 00A2, CENT SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A3[288] = { /* code 00A3, POUND SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x3E, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFC, 0x10,
  0x00, 0x3E, 0xFF, 0xFF, 0xC3, 0x53, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A4[352] = { /* code 00A4, CURRENCY SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0x70, 0x00,
  0x03, 0xEF, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xF7, 0x00,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x03, 0xEF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xC1, 0x00, 0x5F, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xA0, 0x00, 0x3E, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xC1, 0x00, 0x5F, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x03, 0xEF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x3E, 0xFF, 0xFF, 0xC4, 0xEF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFE, 0x80,
  0x00, 0xAF, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x05, 0xFF, 0xE3, 0x00,
  0x00, 0x06, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5E, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A5[288] = { /* code 00A5, YEN SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x7F, 0xFF, 0xFF, 0xF7, 0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A6[256] = { /* code 00A6, BROKEN BAR */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A7[256] = { /* code 00A7, SECTION SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x11, 0x76, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x1C, 0xFF, 0xFF, 0xF7, 0xAF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xF7, 0xAF, 0xFF, 0xFF, 0xA0,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x08, 0x92, 0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0xAF, 0xFF, 0x52, 0xDF, 0xFF, 0xFF, 0x50,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A8[256] = { /* code 00A8, DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFE, 0x30, 0x0A, 0xFF, 0xE3, 0x00,
  0x0A, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0x50,
  0x0A, 0xFF, 0xFF, 0xD2, 0xAF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFE, 0x30, 0x1C, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00A9[352] = { /* code 00A9, COPYRIGHT SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0x70, 0x00, 0x07, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x3E, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xF5, 0x01, 0xCF, 0xFF, 0xFE, 0x30, 0x5F, 0xFC, 0x10,
  0x07, 0xFF, 0x70, 0x5F, 0xFF, 0xFF, 0xFF, 0xFA, 0x07, 0xFF, 0x70,
  0x1C, 0xFC, 0x13, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0x72, 0xDF, 0xC1,
  0x3E, 0xF7, 0x0A, 0xFF, 0xFE, 0x32, 0xDF, 0xFF, 0xC1, 0x7F, 0xE3,
  0x5F, 0xF5, 0x2D, 0xFF, 0xF7, 0x00, 0x00, 0x03, 0xD3, 0x5F, 0xF5,
  0x5F, 0xF5, 0x3E, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x5F, 0xF5,
  0x5F, 0xF5, 0x2D, 0xFF, 0xF7, 0x00, 0x7F, 0xFF, 0xE3, 0x5F, 0xF5,
  0x3E, 0xF7, 0x0A, 0xFF, 0xFE, 0x32, 0xDF, 0xFF, 0xA0, 0x7F, 0xE3,
  0x1C, 0xFC, 0x13, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0x51, 0xCF, 0xC1,
  0x07, 0xFF, 0x70, 0x5F, 0xFF, 0xFF, 0xFF, 0xF7, 0x07, 0xFF, 0x70,
  0x01, 0xCF, 0xF5, 0x02, 0xDF, 0xFF, 0xFD, 0x20, 0x5F, 0xFC, 0x10,
  0x00, 0x3E, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xE3, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0x70, 0x00, 0x07, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00AA[192] = { /* code 00AA, FEMININE ORDINAL INDICATOR */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0x50,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x3E, 0xFF, 0xF5, 0x5F, 0xFF, 0xE3,
  0x3E, 0xFF, 0xF5, 0x3E, 0xFF, 0xE3,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00AB[192] = { /* code 00AB, LEFT-POINTING DOUBLE ANGLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFE, 0xDF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00AC[256] = { /* code 00AC, NOT SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00AD[128] = { /* code 00AD, SOFT HYPHEN */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0xCF, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xF0,
  0xCF, 0xFF, 0xFF, 0xF0,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00AE[352] = { /* code 00AE, REGISTERED SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xA0, 0x00, 0x05, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x2D, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xE3, 0x00,
  0x00, 0xAF, 0xF7, 0xAF, 0xFF, 0xFF, 0xFA, 0x00, 0x5F, 0xFC, 0x10,
  0x05, 0xFF, 0xA0, 0xAF, 0xFF, 0xFF, 0xFF, 0xD2, 0x07, 0xFF, 0x70,
  0x0A, 0xFE, 0x30, 0xAF, 0xFF, 0xFF, 0xFF, 0xF7, 0x01, 0xCF, 0xC1,
  0x2D, 0xFA, 0x00, 0xAF, 0xFF, 0xAA, 0xFF, 0xFA, 0x00, 0x7F, 0xE3,
  0x2D, 0xF7, 0x00, 0xAF, 0xFF, 0xBC, 0xFF, 0xFA, 0x00, 0x5F, 0xF5,
  0x3E, 0xF7, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x5F, 0xF5,
  0x2D, 0xF7, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x5F, 0xF5,
  0x2D, 0xFA, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x7F, 0xE3,
  0x0A, 0xFE, 0x30, 0xAF, 0xFF, 0xFF, 0xFF, 0xC1, 0x01, 0xCF, 0xC1,
  0x05, 0xFF, 0xA0, 0xAF, 0xFF, 0xFF, 0xFF, 0xE3, 0x07, 0xFF, 0x70,
  0x00, 0xAF, 0xF7, 0xAF, 0xFF, 0xAA, 0xFF, 0xFA, 0x5F, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xE3, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xA0, 0x00, 0x07, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B0[192] = { /* code 00B0, DEGREE SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xD2, 0x2D, 0xFF, 0xC1,
  0x3E, 0xFE, 0x30, 0x03, 0xEF, 0xE3,
  0x5F, 0xFD, 0x20, 0x02, 0xDF, 0xF5,
  0x3E, 0xFE, 0x30, 0x03, 0xEF, 0xE3,
  0x1C, 0xFF, 0xD2, 0x2D, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x0A, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B1[352] = { /* code 00B1, PLUS-MINUS SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B2[192] = { /* code 00B2, SUPERSCRIPT TWO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFD, 0x20, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0x70, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x3E, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B3[192] = { /* code 00B3, SUPERSCRIPT THREE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0x70, 0x00,
  0x01, 0xCF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x0A, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xF5, 0x00,
  0x01, 0x76, 0xAF, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x7F, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B4[256] = { /* code 00B4, ACUTE ACCENT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B5[256] = { /* code 00B5, MICRO SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xA0, 0x3E, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B6[352] = { /* code 00B6, PILCROW SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x1C, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xC1, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B8[256] = { /* code 00B8, CEDILLA */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xF5, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00B9[192] = { /* code 00B9, SUPERSCRIPT ONE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00BA[192] = { /* code 00BA, MASCULINE ORDINAL INDICATOR */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x5F, 0xFF, 0xE3, 0xAF, 0xFF, 0xA0,
  0x5F, 0xFF, 0xE3, 0xAF, 0xFF, 0xC0,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00BB[192] = { /* code 00BB, RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10,
  0x01, 0xCF, 0xFF, 0xFF, 0xF7, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xD2, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00BC[416] = { /* code 00BC, VULGAR FRACTION ONE QUARTER */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x5F, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x07, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x2D, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x07, 0xFF, 0xA0, 0x02, 0xDF, 0xFF, 0xFF, 0x50,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x2D, 0xFE, 0x30, 0x05, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x5F, 0xFC, 0x10, 0x1C, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x05, 0xFF, 0xFC, 0x11, 0xCF, 0xF7, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xA0, 0x02, 0xDF, 0xFC, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0x50, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFC, 0x10, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xF7, 0x00, 0x13, 0x20, 0x01, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00BD[416] = { /* code 00BD, VULGAR FRACTION ONE HALF */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x5F, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x07, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x2D, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x03, 0xEF, 0xD2, 0x0A, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x07, 0xFF, 0xA1, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x2D, 0xFE, 0x37, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x05, 0xFF, 0xFC, 0x10, 0x5F, 0xFC, 0x1A, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x05, 0xFF, 0xFC, 0x11, 0xCF, 0xF7, 0x1C, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xD2, 0x0A, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xA0, 0x05, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0x50, 0x00, 0x7F, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFC, 0x10, 0x00, 0x07, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00BE[416] = { /* code 00BE, VULGAR FRACTION THREE QUARTERS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x5F, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0x70, 0x00, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFE, 0x30, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFA, 0x00, 0x00, 0x07, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFC, 0x10, 0x00, 0x2D, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xA0, 0x00, 0x5F, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xE3, 0x01, 0xCF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xF5, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0x76, 0x7F, 0xFF, 0xE3, 0x07, 0xFF, 0xA0, 0x02, 0xDF, 0xFF, 0xFF, 0x50,
  0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x2D, 0xFE, 0x30, 0x05, 0xFF, 0xFF, 0xFF, 0x50,
  0x01, 0xCF, 0xFF, 0xFF, 0x50, 0x5F, 0xFC, 0x10, 0x1C, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xE3, 0x01, 0xCF, 0xF7, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xA0, 0x02, 0xDF, 0xFC, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0x50, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFC, 0x10, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xF7, 0x00, 0x13, 0x20, 0x01, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xD2, 0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00BF[256] = { /* code 00BF, INVERTED QUESTION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C0[288] = { /* code 00C0, LATIN CAPITAL LETTER A WITH GRAVE */
  0x00, 0x07, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x67, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C1[288] = { /* code 00C1, LATIN CAPITAL LETTER A WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x67, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C2[288] = { /* code 00C2, LATIN CAPITAL LETTER A WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x05, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x01, 0x76, 0x00, 0x00, 0x03, 0xE5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C3[288] = { /* code 00C3, LATIN CAPITAL LETTER A WITH TILDE */
  0x00, 0x00, 0x05, 0xFF, 0xC1, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C4[288] = { /* code 00C4, LATIN CAPITAL LETTER A WITH DIAERESIS */
  0x00, 0x02, 0xDF, 0xFA, 0x00, 0x3E, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xF5, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xF5, 0x00,
  0x00, 0x03, 0xEF, 0xFC, 0x10, 0x5F, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C5[288] = { /* code 00C5, LATIN CAPITAL LETTER A WITH RING ABOVE */
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0x8C, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x03, 0xEF, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0xFE, 0xDF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C6[384] = { /* code 00C6, LATIN CAPITAL LETTER AE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFE, 0x3A, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C7[352] = { /* code 00C7, LATIN CAPITAL LETTER C WITH CEDILLA */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x32,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xF5,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD2,
  0x1C, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xA0,
  0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0x50,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C8[256] = { /* code 00C8, LATIN CAPITAL LETTER E WITH GRAVE */
  0x00, 0x2D, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x05, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00C9[256] = { /* code 00C9, LATIN CAPITAL LETTER E WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xD0,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5E, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00CA[256] = { /* code 00CA, LATIN CAPITAL LETTER E WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x1C, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x03, 0xE5, 0x00, 0x00, 0x06, 0x72, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00CB[256] = { /* code 00CB, LATIN CAPITAL LETTER E WITH DIAERESIS */
  0x00, 0x05, 0xFF, 0xF5, 0x00, 0x7F, 0xFE, 0x30,
  0x00, 0x5F, 0xFF, 0xFE, 0x35, 0xFF, 0xFF, 0xE0,
  0x00, 0x7F, 0xFF, 0xFF, 0x7A, 0xFF, 0xFF, 0xF0,
  0x00, 0x5F, 0xFF, 0xFF, 0x57, 0xFF, 0xFF, 0xE0,
  0x00, 0x07, 0xFF, 0xF7, 0x00, 0xAF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00CC[160] = { /* code 00CC, LATIN CAPITAL LETTER I WITH GRAVE */
  0xEF, 0xFF, 0xD2, 0x00, 0x00,
  0x1C, 0xFF, 0xFC, 0x10, 0x00,
  0x01, 0xCF, 0xFF, 0xC1, 0x00,
  0x00, 0x1C, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x5E, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00CD[160] = { /* code 00CD, LATIN CAPITAL LETTER I WITH ACUTE */
  0x00, 0x00, 0x03, 0xEF, 0xFF,
  0x00, 0x00, 0x2D, 0xFF, 0xFA,
  0x00, 0x02, 0xDF, 0xFF, 0xA0,
  0x00, 0x1C, 0xFF, 0xFA, 0x00,
  0x00, 0x5E, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00CE[160] = { /* code 00CE, LATIN CAPITAL LETTER I WITH CIRCUMFLEX */
  0x00, 0x02, 0xDE, 0x30, 0x00,
  0x00, 0x2D, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFF, 0xE3,
  0x35, 0x20, 0x00, 0x01, 0x76,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00CF[160] = { /* code 00CF, LATIN CAPITAL LETTER I WITH DIAERESIS */
  0x3E, 0xF7, 0x00, 0x2D, 0xFA,
  0xFF, 0xFF, 0xA3, 0xEF, 0xFF,
  0xFF, 0xFF, 0xD9, 0xFF, 0xFF,
  0xFF, 0xFF, 0xC6, 0xFF, 0xFF,
  0xCF, 0xFD, 0x20, 0xAF, 0xFF,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D0[352] = { /* code 00D0, LATIN CAPITAL LETTER ETH */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF5,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x3E, 0xFF, 0xFF, 0xF7,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x3E, 0xFF, 0xFF, 0xF7,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x5F, 0xFF, 0xFF, 0xF7,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x7F, 0xFF, 0xFF, 0xF5,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xD2,
  0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D1[288] = { /* code 00D1, LATIN CAPITAL LETTER N WITH TILDE */
  0x00, 0x00, 0x05, 0xFF, 0xC1, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x01, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D2[352] = { /* code 00D2, LATIN CAPITAL LETTER O WITH GRAVE */
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xC1, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x1C, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x67, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D3[352] = { /* code 00D3, LATIN CAPITAL LETTER O WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x35, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D4[352] = { /* code 00D4, LATIN CAPITAL LETTER O WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDD, 0x20, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x67, 0x20, 0x00, 0x01, 0x76, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D5[352] = { /* code 00D5, LATIN CAPITAL LETTER O WITH TILDE */
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFE, 0xDF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D6[352] = { /* code 00D6, LATIN CAPITAL LETTER O WITH DIAERESIS */
  0x00, 0x00, 0x01, 0xCF, 0xFC, 0x10, 0x5F, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xA3, 0xEF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xD9, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFD, 0x20, 0x7F, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xF7,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3,
  0x05, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D7[352] = { /* code 00D7, MULTIPLICATION SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0x76, 0x00, 0x00, 0x00, 0x67, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xA0, 0x00, 0x0A, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFA, 0x00, 0xAF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xAA, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFE, 0x33, 0xEF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xE3, 0x00, 0x3E, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFE, 0x30, 0x00, 0x03, 0xEF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D8[352] = { /* code 00D8, LATIN CAPITAL LETTER O WITH STROKE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xE3, 0x01, 0x99, 0x10,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x05, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xC1,
  0x0A, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x3E, 0xF5, 0x3E, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0x70, 0x2D, 0xFF, 0xFF, 0xFA,
  0x3E, 0xFF, 0xFF, 0xFA, 0x2D, 0xF7, 0x00, 0x3E, 0xFF, 0xFF, 0xF7,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x7F, 0xFF, 0xFF, 0xF5,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3,
  0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x02, 0xDF, 0x50, 0x1C, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00D9[288] = { /* code 00D9, LATIN CAPITAL LETTER U WITH GRAVE */
  0x00, 0x07, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x67, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00DA[288] = { /* code 00DA, LATIN CAPITAL LETTER U WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x67, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00DB[288] = { /* code 00DB, LATIN CAPITAL LETTER U WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x05, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x01, 0x76, 0x00, 0x00, 0x03, 0xE5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00DC[288] = { /* code 00DC, LATIN CAPITAL LETTER U WITH DIAERESIS */
  0x00, 0x05, 0xFF, 0xF5, 0x02, 0xDF, 0xFC, 0x10, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0x9D, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xF7, 0x02, 0xDF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x27, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFF, 0x6C, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00DD[256] = { /* code 00DD, LATIN CAPITAL LETTER Y WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x15, 0x40, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFF, 0xFD, 0x20, 0x0A, 0xFF, 0xFF, 0xF0,
  0xDF, 0xFF, 0xFF, 0xA0, 0x5F, 0xFF, 0xFF, 0xF0,
  0x5F, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFF, 0xA0,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00DE[288] = { /* code 00DE, LATIN CAPITAL LETTER THORN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFF, 0xA2, 0xDF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xC0,
  0x05, 0xFF, 0xFF, 0xFF, 0x53, 0xEF, 0xFF, 0xFF, 0xC0,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00DF[288] = { /* code 00DF, LATIN SMALL LETTER SHARP S */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x07, 0xFF, 0xFF, 0xFC, 0x1A, 0xFF, 0xFF, 0xA0, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x05, 0xFF, 0xFF, 0x70, 0x00,
  0x07, 0xFF, 0xFF, 0xFE, 0x4C, 0xFF, 0xFE, 0x30, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x07, 0xFF, 0xFF, 0xFE, 0x30,
  0x07, 0xFF, 0xFF, 0xFA, 0x00, 0xAF, 0xFF, 0xFF, 0x50,
  0x07, 0xFF, 0xFF, 0xFA, 0x03, 0xEF, 0xFF, 0xFF, 0x50,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E0[288] = { /* code 00E0, LATIN SMALL LETTER A WITH GRAVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x02, 0x53, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E1[288] = { /* code 00E1, LATIN SMALL LETTER A WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E2[288] = { /* code 00E2, LATIN SMALL LETTER A WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0x53, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x67, 0x20, 0x00, 0x06, 0x72, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E3[288] = { /* code 00E3, LATIN SMALL LETTER A WITH TILDE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFE, 0xDF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E4[288] = { /* code 00E4, LATIN SMALL LETTER A WITH DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xF5, 0x01, 0xCF, 0xFE, 0x30, 0x00,
  0x00, 0x7F, 0xFF, 0xFE, 0x3A, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0x9D, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFE, 0x3A, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x0A, 0xFF, 0xF5, 0x01, 0xCF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E5[288] = { /* code 00E5, LATIN SMALL LETTER A WITH RING ABOVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0x9D, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0x9D, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x3E, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFD, 0x20,
  0x5F, 0xFF, 0xFF, 0xD2, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x3E, 0xFF, 0xFF, 0xF7, 0x03, 0xEF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E6[416] = { /* code 00E6, LATIN SMALL LETTER AE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0xAF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFE, 0x30, 0x3E, 0xFF, 0xFF, 0xD2,
  0x3E, 0xFF, 0xFF, 0xE3, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x3E, 0xFF, 0xFF, 0xE3, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x2D, 0xFF, 0xFF, 0xFA, 0x03, 0xEF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x89, 0x20, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC3, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E7[288] = { /* code 00E7, LATIN SMALL LETTER C WITH CEDILLA */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x0A, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0x1C, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFC, 0x1A, 0xFF, 0xFF, 0xFC, 0x10,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x19, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E8[288] = { /* code 00E8, LATIN SMALL LETTER E WITH GRAVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x04, 0x51, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xF7, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x39, 0x91, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x33, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00E9[288] = { /* code 00E9, LATIN SMALL LETTER E WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x67, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xF7, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x39, 0x91, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x33, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00EA[288] = { /* code 00EA, LATIN SMALL LETTER E WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x04, 0x51, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x02, 0x76, 0x00, 0x00, 0x27, 0x60, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xF7, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x39, 0x91, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x33, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00EB[288] = { /* code 00EB, LATIN SMALL LETTER E WITH DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xD2, 0x00, 0xAF, 0xFF, 0x50, 0x00,
  0x01, 0xCF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFE, 0x4C, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFC, 0x1A, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x2D, 0xFF, 0xD2, 0x01, 0xCF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xF7, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFD, 0x39, 0x91, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFC, 0x33, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00EC[160] = { /* code 00EC, LATIN SMALL LETTER I WITH GRAVE */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xD2, 0x00, 0x00,
  0x03, 0xEF, 0xFC, 0x10, 0x00,
  0x00, 0x3E, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x05, 0xE3, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00ED[160] = { /* code 00ED, LATIN SMALL LETTER I WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xD0,
  0x00, 0x0A, 0xFF, 0xF5, 0x00,
  0x00, 0xAF, 0xFF, 0x50, 0x00,
  0x02, 0x53, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00EE[160] = { /* code 00EE, LATIN SMALL LETTER I WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xD3, 0x00, 0x00,
  0x00, 0x3E, 0xFE, 0x30, 0x00,
  0x03, 0xEF, 0xFF, 0xE3, 0x00,
  0x3E, 0xFF, 0xFF, 0xFF, 0x50,
  0x67, 0x10, 0x00, 0x06, 0x70,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00EF[160] = { /* code 00EF, LATIN SMALL LETTER I WITH DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFE, 0x3A, 0xFF, 0xF0,
  0xFF, 0xFF, 0x9D, 0xFF, 0xF0,
  0xFF, 0xFF, 0x6C, 0xFF, 0xF0,
  0xFF, 0xF7, 0x03, 0xEF, 0xF0,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F0[288] = { /* code 00F0, LATIN SMALL LETTER ETH */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x50,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F1[256] = { /* code 00F1, LATIN SMALL LETTER N WITH TILDE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F2[288] = { /* code 00F2, LATIN SMALL LETTER O WITH GRAVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x06, 0x72, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F3[288] = { /* code 00F3, LATIN SMALL LETTER O WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F4[288] = { /* code 00F4, LATIN SMALL LETTER O WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x04, 0x51, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x01, 0x76, 0x00, 0x00, 0x27, 0x60, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F5[288] = { /* code 00F5, LATIN SMALL LETTER O WITH TILDE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xDE, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F6[288] = { /* code 00F6, LATIN SMALL LETTER O WITH DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xE3, 0x00, 0xAF, 0xFE, 0x30, 0x00,
  0x01, 0xCF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFE, 0x4C, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFD, 0x2A, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x2D, 0xFF, 0xD2, 0x01, 0xCF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xE3, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F7[352] = { /* code 00F7, DIVISION SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x1C, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x1C, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x1C, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x1C, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F8[288] = { /* code 00F8, LATIN SMALL LETTER O WITH STROKE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x02, 0xDD, 0x20,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xFF, 0x70,
  0x3E, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xFF, 0xF5, 0x7F, 0xFF, 0xFF, 0xA0,
  0x3E, 0xFF, 0xFF, 0xFE, 0x35, 0xFF, 0xFF, 0xFF, 0x70,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0xAF, 0xC1, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00F9[256] = { /* code 00F9, LATIN SMALL LETTER U WITH GRAVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x17, 0x60, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00FA[256] = { /* code 00FA, LATIN SMALL LETTER U WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x04, 0x51, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00FB[256] = { /* code 00FB, LATIN SMALL LETTER U WITH CIRCUMFLEX */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x03, 0xE5, 0x00, 0x00, 0x3E, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00FC[256] = { /* code 00FC, LATIN SMALL LETTER U WITH DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xA0, 0x05, 0xFF, 0xFA, 0x00,
  0x03, 0xEF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0x70,
  0x05, 0xFF, 0xFF, 0xFC, 0x8F, 0xFF, 0xFF, 0xC1,
  0x03, 0xEF, 0xFF, 0xFA, 0x3E, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xA0, 0x05, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFA, 0x5F, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00FD[256] = { /* code 00FD, LATIN SMALL LETTER Y WITH ACUTE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x06, 0x71, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x7F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xA0,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00FE[288] = { /* code 00FE, LATIN SMALL LETTER THORN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFD, 0x23, 0xEF, 0xFF, 0xFF, 0x70,
  0x1C, 0xFF, 0xFF, 0xF7, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0xAF, 0xFF, 0xFF, 0xA0,
  0x1C, 0xFF, 0xFF, 0xFE, 0x35, 0xFF, 0xFF, 0xFF, 0x70,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_00FF[256] = { /* code 00FF, LATIN SMALL LETTER Y WITH DIAERESIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xA0, 0x05, 0xFF, 0xFA, 0x00,
  0x03, 0xEF, 0xFF, 0xF7, 0x3E, 0xFF, 0xFF, 0xA0,
  0x05, 0xFF, 0xFF, 0xFC, 0x6F, 0xFF, 0xFF, 0xC1,
  0x03, 0xEF, 0xFF, 0xF7, 0x3E, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xA0, 0x05, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xF7, 0x5F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFA, 0x7F, 0xFF, 0xFF, 0xC1,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xA0,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Latin Extended-A> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0131[160] = { /* code 0131, LATIN SMALL LETTER DOTLESS I */
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0152[448] = { /* code 0152, LATIN CAPITAL LIGATURE OE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x03, 0xEF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x1C, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x0A, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFC, 0x10, 0x5F, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0153[416] = { /* code 0153, LATIN SMALL LIGATURE OE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF5, 0x00, 0xAF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0xAF, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFA, 0x1C, 0xFF, 0xFF, 0xFE, 0x30, 0x3E, 0xFF, 0xFF, 0xC1,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2,
  0x3E, 0xFF, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2,
  0x2D, 0xFF, 0xFF, 0xF7, 0x1C, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC2, 0x99, 0x10, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFA, 0x02, 0xDF, 0xFF, 0xFF, 0xC3, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0160[224] = { /* code 0160, LATIN CAPITAL LETTER S WITH CARON */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x00, 0x00, 0x07, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFA, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xE3, 0x00,
  0x13, 0x25, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0161[192] = { /* code 0161, LATIN SMALL LETTER S WITH CARON */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xF0,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF0,
  0x00, 0x00, 0x01, 0xCF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x1C, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xD0,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xD0,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xD0,
  0x00, 0x3E, 0xFF, 0xFF, 0xFA, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0xCF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0xCF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0xCF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0xCF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0178[256] = { /* code 0178, LATIN CAPITAL LETTER Y WITH DIAERESIS */
  0x00, 0x7F, 0xFF, 0x50, 0x1C, 0xFF, 0xD2, 0x00,
  0x05, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFC, 0x10,
  0x07, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFD, 0x20,
  0x05, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFC, 0x10,
  0x00, 0x7F, 0xFF, 0x70, 0x2D, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xFF, 0xFF, 0xFD, 0x20, 0x0A, 0xFF, 0xFF, 0xF0,
  0xDF, 0xFF, 0xFF, 0xA0, 0x5F, 0xFF, 0xFF, 0xF0,
  0x5F, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFF, 0xA0,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Latin Extended-B> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_0192[288] = { /* code 0192, LATIN SMALL LETTER F WITH HOOK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Spacing Modifier Letters> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02C6[256] = { /* code 02C6, MODIFIER LETTER CIRCUMFLEX ACCENT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5E, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02C7[256] = { /* code 02C7, CARON */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x0A, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0x70, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02C9[256] = { /* code 02C9, MODIFIER LETTER MACRON */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFA, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02D8[256] = { /* code 02D8, BREVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02D9[256] = { /* code 02D9, DOT ABOVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02DA[256] = { /* code 02DA, RING ABOVE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02DB[256] = { /* code 02DB, OGONEK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02DC[256] = { /* code 02DC, SMALL TILDE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFD, 0xBF, 0xF7, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xBD, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_02DD[256] = { /* code 02DD, DOUBLE ACUTE ACCENT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0xAF, 0xFD, 0xBF, 0xFD, 0x20, 0x00,
  0x00, 0x1C, 0xFF, 0xED, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Basic Greek> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_03C0[320] = { /* code 03C0, GREEK SMALL LETTER PI */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x5F, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <General Punctuation> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2013[256] = { /* code 2013, EN DASH */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2014[320] = { /* code 2014, EM DASH */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2018[192] = { /* code 2018, LEFT SINGLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0x70, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF7, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x07, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2019[192] = { /* code 2019, RIGHT SINGLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x1C, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_201A[192] = { /* code 201A, SINGLE LOW-9 QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xC1, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x00, 0x1C, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_201C[320] = { /* code 201C, LEFT DOUBLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xEC, 0x10, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0x70, 0x00, 0x3E, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xA1, 0xCF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF9, 0xDF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xD2, 0x7F, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x07, 0xFF, 0xFD, 0x20, 0x0A, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_201D[320] = { /* code 201D, RIGHT DOUBLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFF, 0xC1, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF9, 0xDF, 0xFF, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xA0, 0x1C, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x1C, 0xF5, 0x00, 0x00, 0x3E, 0xE3, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_201E[320] = { /* code 201E, DOUBLE LOW-9 QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFE, 0x30, 0x0A, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xE3, 0xAF, 0xFF, 0xFF, 0xC1, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF9, 0xDF, 0xFF, 0xFF, 0xE3, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xA0, 0x3E, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x1C, 0xF5, 0x00, 0x00, 0x3E, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2020[256] = { /* code 2020, DAGGER */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2021[256] = { /* code 2021, DOUBLE DAGGER */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2022[320] = { /* code 2022, BULLET */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2026[544] = { /* code 2026, HORIZONTAL ELLIPSIS */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x13, 0x20, 0x00, 0x00, 0x00, 0x01, 0x32, 0x00, 0x00, 0x00, 0x00, 0x23, 0x10, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xA0, 0x00, 0x03, 0xEF, 0xFF, 0xF7, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xF5, 0x00, 0x1C, 0xFF, 0xFF, 0xFE, 0x30, 0x02, 0xDF, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xFA, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x70, 0x03, 0xEF, 0xFF, 0xFF, 0xF5, 0x00,
  0x01, 0xCF, 0xFF, 0xFF, 0xF7, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0x50, 0x03, 0xEF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xE3, 0x00, 0x0A, 0xFF, 0xFF, 0xFD, 0x20, 0x01, 0xCF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x07, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0xAF, 0xFF, 0xD2, 0x00, 0x00, 0x1C, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2030[640] = { /* code 2030, PER MILLE SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFD, 0x20, 0x00, 0x05, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x1C, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x3E, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0x50, 0xAF, 0xFF, 0xA0, 0x7F, 0xD2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFA, 0x00, 0x2D, 0xFF, 0xC3, 0xDF, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xFA, 0x00, 0x2D, 0xFF, 0xC6, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x01, 0xCF, 0xFF, 0x50, 0xAF, 0xFF, 0xAA, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xF5, 0x7F, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFD, 0x22, 0xDF, 0xA0, 0x07, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0xFF, 0x51, 0xCF, 0xFF, 0xFF, 0xFF, 0x50, 0x01, 0xCF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x0A, 0xFC, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0xF7, 0x2D, 0xFF, 0xF5, 0x0A, 0xFF, 0xF7, 0x3E, 0xFF, 0xE3, 0x1C, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xE3, 0x3E, 0xFF, 0x70, 0x02, 0xDF, 0xFA, 0x5F, 0xFF, 0x70, 0x03, 0xEF, 0xF7, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xA0, 0x3E, 0xFF, 0x70, 0x02, 0xDF, 0xFC, 0x6F, 0xFF, 0x70, 0x03, 0xEF, 0xFA, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x05, 0xFF, 0x50, 0x2D, 0xFF, 0xF5, 0x1C, 0xFF, 0xF7, 0x3E, 0xFF, 0xE3, 0x1C, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x0A, 0xFD, 0x20, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x3E, 0xF7, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0x50, 0x01, 0xCF, 0xFF, 0xFF, 0xFE, 0x30, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xE3, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2039[128] = { /* code 2039, SINGLE LEFT-POINTING ANGLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xA0,
  0x00, 0x7F, 0xFD, 0x20,
  0x02, 0xDF, 0xFA, 0x00,
  0x05, 0xFF, 0xE3, 0x00,
  0x1C, 0xFF, 0xC1, 0x00,
  0x07, 0xFF, 0xE3, 0x00,
  0x02, 0xDF, 0xF7, 0x00,
  0x00, 0xAF, 0xFD, 0x20,
  0x00, 0x3E, 0xFF, 0xA0,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_203A[128] = { /* code 203A, SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x1C, 0xFF, 0xD2, 0x00,
  0x03, 0xEF, 0xF5, 0x00,
  0x01, 0xCF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0x50,
  0x00, 0x2D, 0xFF, 0xA0,
  0x00, 0x5F, 0xFE, 0x30,
  0x01, 0xCF, 0xFC, 0x10,
  0x03, 0xEF, 0xF5, 0x00,
  0x1C, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Currency Symbol> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_20AC[288] = { /* code 20AC, EURO SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x80,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xF5, 0x2D, 0xD2, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xE3, 0x2D, 0xD2, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Letterlike Symbols> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2122[384] = { /* code 2122, TRADE MARK SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xFF, 0xF5, 0x2D, 0xFF, 0xFC, 0xBF, 0xFF, 0xF5, 0x00,
  0xDF, 0xFF, 0xFF, 0xFF, 0xF6, 0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x5F, 0xFF, 0xD2, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2126[320] = { /* code 2126, OHM SIGN */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xD2, 0x00,
  0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFF, 0xC1, 0x07, 0xFF, 0xFF, 0xFF, 0x70,
  0x0A, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFF, 0xD2,
  0x2D, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xF5,
  0x3E, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0xF7,
  0x3E, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFA,
  0x5F, 0xFF, 0xFF, 0x70, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFA,
  0x2D, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xF7,
  0x1C, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0xD2,
  0x05, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0x70,
  0x00, 0x7F, 0xFF, 0xF7, 0x00, 0x00, 0x5F, 0xFF, 0xF7, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0x50, 0x05, 0xFF, 0xFF, 0x50, 0x00,
  0x5F, 0xFF, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x5F, 0xFF, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x5F, 0xFF, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x5F, 0xFF, 0xFF, 0xFF, 0xF6, 0xCF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Mathematical Operators> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2202[256] = { /* code 2202, PARTIAL DIFFERENTIAL */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x03, 0xEF, 0xF7, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xC1, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFD, 0x20,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x70,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0,
  0x3E, 0xFF, 0xFF, 0xA0, 0x3E, 0xFF, 0xFF, 0xD0,
  0x7F, 0xFF, 0xFC, 0x10, 0x07, 0xFF, 0xFF, 0xD0,
  0x7F, 0xFF, 0xFA, 0x00, 0x05, 0xFF, 0xFF, 0xD0,
  0x7F, 0xFF, 0xFC, 0x10, 0x07, 0xFF, 0xFF, 0xC0,
  0x5F, 0xFF, 0xFF, 0xA0, 0x5F, 0xFF, 0xFF, 0x70,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2206[320] = { /* code 2206, INCREMENT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0x70, 0x00, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xFF, 0xF9, 0xDF, 0xFF, 0xE3, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xE4, 0xCF, 0xFF, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xC1, 0x7F, 0xFF, 0xFC, 0x10, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xA0, 0x3E, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x2D, 0xFF, 0xFF, 0xA0, 0x00,
  0x00, 0x7F, 0xFF, 0xFD, 0x20, 0x0A, 0xFF, 0xFF, 0xD2, 0x00,
  0x01, 0xCF, 0xFF, 0xFA, 0x00, 0x05, 0xFF, 0xFF, 0xF5, 0x00,
  0x03, 0xEF, 0xFF, 0xF5, 0x00, 0x02, 0xDF, 0xFF, 0xFA, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x3E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE3,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_220F[320] = { /* code 220F, N-ARY PRODUCT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFC, 0x10, 0x00, 0x5F, 0xFF, 0xFC, 0x10,
  0x7F, 0xFF, 0xFF, 0xFF, 0xF5, 0xAF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xFF, 0xF5, 0xAF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xFF, 0xF5, 0xAF, 0xFF, 0xFF, 0xFF, 0xF5,
  0x7F, 0xFF, 0xFF, 0xFF, 0xF5, 0xAF, 0xFF, 0xFF, 0xFF, 0xF5
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2211[320] = { /* code 2211, N-ARY SUMMATION */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xA0,
  0x03, 0xEF, 0xFF, 0xFF, 0x70, 0x00, 0x0A, 0xFF, 0xFF, 0xA0,
  0x00, 0x5F, 0xFF, 0xFF, 0xF5, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xD2, 0x00, 0x0A, 0xFF, 0xFF, 0xC1,
  0x05, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x0A, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2215[ 64] = { /* code 2215, DIVISION SLASH */
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x01,
  0x00, 0x03,
  0x00, 0x0A,
  0x00, 0x2D,
  0x00, 0x5F,
  0x01, 0xCF,
  0x03, 0xEF,
  0x0A, 0xFF,
  0x2D, 0xFE,
  0x5F, 0xFC,
  0xCF, 0xF7,
  0xEF, 0xD2,
  0xFF, 0xA0,
  0xFE, 0x30,
  0xFC, 0x10,
  0xF7, 0x00,
  0xD2, 0x00,
  0xA0, 0x00,
  0x50, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00,
  0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2219[192] = { /* code 2219, BULLET OPERATOR */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x7F, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x02, 0xDF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_221A[320] = { /* code 221A, SQUARE ROOT */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFA,
  0x00, 0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFF, 0xFA,
  0x00, 0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFA,
  0x00, 0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xFF, 0xFA,
  0x00, 0x00, 0x00, 0x00, 0x05, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFA, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xF5, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0x55, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xAA, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xCC, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0xDF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00, 0x00,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFE, 0x30, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x1C, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x0A, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x03, 0xEF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_221E[320] = { /* code 221E, INFINITY */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x07, 0xFF, 0xFF, 0xF7, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC1,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x5F, 0xFF, 0xF5, 0x2D, 0xFF, 0xFF, 0xC1, 0x2D, 0xFF, 0xFC,
  0x5F, 0xFF, 0xC1, 0x07, 0xFF, 0xFE, 0x30, 0x07, 0xFF, 0xFC,
  0x5F, 0xFF, 0xF5, 0x5F, 0xFF, 0xFF, 0xE3, 0x2D, 0xFF, 0xFC,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7,
  0x05, 0xFF, 0xFF, 0xFF, 0xF7, 0xAF, 0xFF, 0xFF, 0xFF, 0xA0,
  0x00, 0x3E, 0xFF, 0xFD, 0x20, 0x03, 0xEF, 0xFF, 0xF5, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_222B[256] = { /* code 222B, INTEGRAL */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x02, 0xDF, 0xFF, 0xFF, 0x70,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFE, 0x30,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x3E, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xD2, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xC1, 0x00, 0x00,
  0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00,
  0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x0A, 0xFF, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00,
  0x1C, 0xFF, 0xFF, 0xFF, 0xD2, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2248[256] = { /* code 2248, ALMOST EQUAL TO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x17, 0x60, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0,
  0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x30,
  0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF7, 0x00,
  0x02, 0xDE, 0x30, 0x5F, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x3E, 0xFF, 0xFF, 0x50, 0x2D, 0xD2, 0x00,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0,
  0xAF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x5E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00,
  0x00, 0x67, 0x10, 0x5F, 0xFF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2260[256] = { /* code 2260, NOT EQUAL TO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x29, 0x80, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0xAF, 0xFF, 0x50, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFF, 0xE3, 0x00,
  0x00, 0x00, 0x00, 0x0A, 0xFF, 0xFF, 0x50, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x1C, 0xFF, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x7F, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xD2, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x07, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2264[256] = { /* code 2264, LESS-THAN OR EQUAL TO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xED, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0xAF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x3E, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_2265[256] = { /* code 2265, GREATER-THAN OR EQUAL TO */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFC, 0x10, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xF5, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x1C, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x1C, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xC1, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFE, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x2D, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0x20,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Geometric Shapes> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_25CA[320] = { /* code 25CA, LOZENGE */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x15, 0x40, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x05, 0xFF, 0xFD, 0x20, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xD2, 0x5F, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x07, 0xFF, 0x50, 0x0A, 0xFE, 0x30, 0x00, 0x00,
  0x00, 0x00, 0x3E, 0xFA, 0x00, 0x02, 0xDF, 0xC1, 0x00, 0x00,
  0x00, 0x01, 0xCF, 0xC1, 0x00, 0x00, 0x3E, 0xF7, 0x00, 0x00,
  0x00, 0x07, 0xFE, 0x30, 0x00, 0x00, 0x07, 0xFE, 0x30, 0x00,
  0x00, 0x5F, 0xF7, 0x00, 0x00, 0x00, 0x01, 0xCF, 0xD2, 0x00,
  0x02, 0xDF, 0xC1, 0x00, 0x00, 0x00, 0x00, 0x3E, 0xFA, 0x00,
  0x00, 0x3E, 0xFA, 0x00, 0x00, 0x00, 0x02, 0xDF, 0xC1, 0x00,
  0x00, 0x07, 0xFF, 0x50, 0x00, 0x00, 0x0A, 0xFE, 0x30, 0x00,
  0x00, 0x01, 0xCF, 0xD2, 0x00, 0x00, 0x5F, 0xF7, 0x00, 0x00,
  0x00, 0x00, 0x2D, 0xFA, 0x00, 0x02, 0xDF, 0xA0, 0x00, 0x00,
  0x00, 0x00, 0x05, 0xFF, 0x70, 0x0A, 0xFD, 0x20, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xAF, 0xE3, 0x7F, 0xF5, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x2D, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x03, 0xEF, 0xFC, 0x10, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x7F, 0xE3, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x15, 0x40, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Private Use Area> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_F001[288] = { /* code F001 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x2D, 0xFF, 0xD2, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xF8, 0xCF, 0xFF, 0xFA, 0x00,
  0x00, 0x00, 0x7F, 0xFF, 0xF9, 0xDF, 0xFF, 0xFD, 0x20,
  0x00, 0x07, 0xFF, 0xFF, 0xF8, 0xCF, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFF, 0xF7, 0x2D, 0xFF, 0xD2, 0x00,
  0x00, 0xAF, 0xFF, 0xFF, 0xF7, 0x00, 0x00, 0x00, 0x00,
  0x02, 0xDF, 0xFF, 0xFF, 0xA5, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFD, 0x25, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_F002[288] = { /* code F002 */
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x7F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x07, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x01, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x02, 0xDF, 0xFF, 0xFF, 0xC6, 0xFF, 0xFF, 0xFC, 0x10,
  0x03, 0xEF, 0xFF, 0xFD, 0x25, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x05, 0xFF, 0xFF, 0xFC, 0x15, 0xFF, 0xFF, 0xFC, 0x10,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

/* Start of unicode area <Special> */
GUI_CONST_STORAGE unsigned char acGUI_FontBauhaus9332_FFFF[128] = { /* code FFFF */
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x5F, 0xFF, 0xFF, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0x50, 0x05, 0xF5,
  0x5F, 0xFF, 0xFF, 0xF5,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

GUI_CONST_STORAGE GUI_CHARINFO GUI_FontBauhaus9332_CharInfo[241] = {
   {   8,   8,  4, acGUI_FontBauhaus9332_0020 } /* code 0020 */
  ,{  13,  13,  7, acGUI_FontBauhaus9332_0021 } /* code 0021 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0022 } /* code 0022 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_0023 } /* code 0023 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0024 } /* code 0024 */
  ,{  27,  27, 14, acGUI_FontBauhaus9332_0025 } /* code 0025 */
  ,{  23,  23, 12, acGUI_FontBauhaus9332_0026 } /* code 0026 */
  ,{   8,   8,  4, acGUI_FontBauhaus9332_0027 } /* code 0027 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_0028 } /* code 0028 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_0029 } /* code 0029 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_002A } /* code 002A */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_002B } /* code 002B */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_002C } /* code 002C */
  ,{   7,   7,  4, acGUI_FontBauhaus9332_002D } /* code 002D */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_002E } /* code 002E */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_002F } /* code 002F */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0030 } /* code 0030 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0031 } /* code 0031 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0032 } /* code 0032 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0033 } /* code 0033 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0034 } /* code 0034 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0035 } /* code 0035 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0036 } /* code 0036 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0037 } /* code 0037 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0038 } /* code 0038 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0039 } /* code 0039 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_003A } /* code 003A */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_003B } /* code 003B */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_003C } /* code 003C */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_003D } /* code 003D */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_003E } /* code 003E */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_003F } /* code 003F */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_0040 } /* code 0040 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_0041 } /* code 0041 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0042 } /* code 0042 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_0043 } /* code 0043 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_0044 } /* code 0044 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0045 } /* code 0045 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0046 } /* code 0046 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_0047 } /* code 0047 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_0048 } /* code 0048 */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_0049 } /* code 0049 */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_004A } /* code 004A */
  ,{  19,  19, 10, acGUI_FontBauhaus9332_004B } /* code 004B */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_004C } /* code 004C */
  ,{  24,  24, 12, acGUI_FontBauhaus9332_004D } /* code 004D */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_004E } /* code 004E */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_004F } /* code 004F */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0050 } /* code 0050 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_0051 } /* code 0051 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_0052 } /* code 0052 */
  ,{  13,  13,  7, acGUI_FontBauhaus9332_0053 } /* code 0053 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_0054 } /* code 0054 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_0055 } /* code 0055 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_0056 } /* code 0056 */
  ,{  24,  24, 12, acGUI_FontBauhaus9332_0057 } /* code 0057 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0058 } /* code 0058 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0059 } /* code 0059 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_005A } /* code 005A */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_005B } /* code 005B */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_005C } /* code 005C */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_005D } /* code 005D */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_005E } /* code 005E */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_005F } /* code 005F */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0060 } /* code 0060 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_0061 } /* code 0061 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0062 } /* code 0062 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0063 } /* code 0063 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0064 } /* code 0064 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0065 } /* code 0065 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_0066 } /* code 0066 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0067 } /* code 0067 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_0068 } /* code 0068 */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_0069 } /* code 0069 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_006A } /* code 006A */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_006B } /* code 006B */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_006C } /* code 006C */
  ,{  23,  23, 12, acGUI_FontBauhaus9332_006D } /* code 006D */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_006E } /* code 006E */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_006F } /* code 006F */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0070 } /* code 0070 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0071 } /* code 0071 */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_0072 } /* code 0072 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_0073 } /* code 0073 */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_0074 } /* code 0074 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_0075 } /* code 0075 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_0076 } /* code 0076 */
  ,{  23,  23, 12, acGUI_FontBauhaus9332_0077 } /* code 0077 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_0078 } /* code 0078 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_0079 } /* code 0079 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_007A } /* code 007A */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_007B } /* code 007B */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_007C } /* code 007C */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_007D } /* code 007D */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_007E } /* code 007E */
  ,{   8,   8,  4, acGUI_FontBauhaus9332_00A0 } /* code 00A0 */
  ,{  13,  13,  7, acGUI_FontBauhaus9332_00A1 } /* code 00A1 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00A2 } /* code 00A2 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00A3 } /* code 00A3 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00A4 } /* code 00A4 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00A5 } /* code 00A5 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00A6 } /* code 00A6 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00A7 } /* code 00A7 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00A8 } /* code 00A8 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00A9 } /* code 00A9 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00AA } /* code 00AA */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00AB } /* code 00AB */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00AC } /* code 00AC */
  ,{   7,   7,  4, acGUI_FontBauhaus9332_00AD } /* code 00AD */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00AE } /* code 00AE */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00B0 } /* code 00B0 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00B1 } /* code 00B1 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00B2 } /* code 00B2 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00B3 } /* code 00B3 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00B4 } /* code 00B4 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00B5 } /* code 00B5 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00B6 } /* code 00B6 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00B8 } /* code 00B8 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00B9 } /* code 00B9 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_00BA } /* code 00BA */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_00BB } /* code 00BB */
  ,{  26,  26, 13, acGUI_FontBauhaus9332_00BC } /* code 00BC */
  ,{  26,  26, 13, acGUI_FontBauhaus9332_00BD } /* code 00BD */
  ,{  26,  26, 13, acGUI_FontBauhaus9332_00BE } /* code 00BE */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00BF } /* code 00BF */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00C0 } /* code 00C0 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00C1 } /* code 00C1 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00C2 } /* code 00C2 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00C3 } /* code 00C3 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00C4 } /* code 00C4 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00C5 } /* code 00C5 */
  ,{  23,  23, 12, acGUI_FontBauhaus9332_00C6 } /* code 00C6 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00C7 } /* code 00C7 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00C8 } /* code 00C8 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00C9 } /* code 00C9 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00CA } /* code 00CA */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00CB } /* code 00CB */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_00CC } /* code 00CC */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_00CD } /* code 00CD */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_00CE } /* code 00CE */
  ,{  10,  10,  5, acGUI_FontBauhaus9332_00CF } /* code 00CF */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D0 } /* code 00D0 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00D1 } /* code 00D1 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D2 } /* code 00D2 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D3 } /* code 00D3 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D4 } /* code 00D4 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D5 } /* code 00D5 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D6 } /* code 00D6 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D7 } /* code 00D7 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00D8 } /* code 00D8 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00D9 } /* code 00D9 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00DA } /* code 00DA */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00DB } /* code 00DB */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00DC } /* code 00DC */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_00DD } /* code 00DD */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00DE } /* code 00DE */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00DF } /* code 00DF */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00E0 } /* code 00E0 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00E1 } /* code 00E1 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00E2 } /* code 00E2 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00E3 } /* code 00E3 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00E4 } /* code 00E4 */
  ,{  18,  18,  9, acGUI_FontBauhaus9332_00E5 } /* code 00E5 */
  ,{  26,  26, 13, acGUI_FontBauhaus9332_00E6 } /* code 00E6 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00E7 } /* code 00E7 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00E8 } /* code 00E8 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00E9 } /* code 00E9 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00EA } /* code 00EA */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00EB } /* code 00EB */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_00EC } /* code 00EC */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_00ED } /* code 00ED */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_00EE } /* code 00EE */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_00EF } /* code 00EF */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F0 } /* code 00F0 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00F1 } /* code 00F1 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F2 } /* code 00F2 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F3 } /* code 00F3 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F4 } /* code 00F4 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F5 } /* code 00F5 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F6 } /* code 00F6 */
  ,{  22,  22, 11, acGUI_FontBauhaus9332_00F7 } /* code 00F7 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00F8 } /* code 00F8 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00F9 } /* code 00F9 */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00FA } /* code 00FA */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00FB } /* code 00FB */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00FC } /* code 00FC */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00FD } /* code 00FD */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_00FE } /* code 00FE */
  ,{  16,  16,  8, acGUI_FontBauhaus9332_00FF } /* code 00FF */
  ,{   9,   9,  5, acGUI_FontBauhaus9332_0131 } /* code 0131 */
  ,{  28,  28, 14, acGUI_FontBauhaus9332_0152 } /* code 0152 */
  ,{  26,  26, 13, acGUI_FontBauhaus9332_0153 } /* code 0153 */
  ,{  13,  13,  7, acGUI_FontBauhaus9332_0160 } /* code 0160 */
  ,{  11,  11,  6, acGUI_FontBauhaus9332_0161 } /* code 0161 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_0178 } /* code 0178 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_0192 } /* code 0192 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02C6 } /* code 02C6 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02C7 } /* code 02C7 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02C9 } /* code 02C9 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02D8 } /* code 02D8 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02D9 } /* code 02D9 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02DA } /* code 02DA */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02DB } /* code 02DB */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02DC } /* code 02DC */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_02DD } /* code 02DD */
  ,{  19,  19, 10, acGUI_FontBauhaus9332_03C0 } /* code 03C0 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2013 } /* code 2013 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_2014 } /* code 2014 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_2018 } /* code 2018 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_2019 } /* code 2019 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_201A } /* code 201A */
  ,{  19,  19, 10, acGUI_FontBauhaus9332_201C } /* code 201C */
  ,{  19,  19, 10, acGUI_FontBauhaus9332_201D } /* code 201D */
  ,{  19,  19, 10, acGUI_FontBauhaus9332_201E } /* code 201E */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2020 } /* code 2020 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2021 } /* code 2021 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_2022 } /* code 2022 */
  ,{  33,  33, 17, acGUI_FontBauhaus9332_2026 } /* code 2026 */
  ,{  39,  39, 20, acGUI_FontBauhaus9332_2030 } /* code 2030 */
  ,{   8,   8,  4, acGUI_FontBauhaus9332_2039 } /* code 2039 */
  ,{   8,   8,  4, acGUI_FontBauhaus9332_203A } /* code 203A */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_20AC } /* code 20AC */
  ,{  23,  23, 12, acGUI_FontBauhaus9332_2122 } /* code 2122 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_2126 } /* code 2126 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2202 } /* code 2202 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_2206 } /* code 2206 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_220F } /* code 220F */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_2211 } /* code 2211 */
  ,{   4,   4,  2, acGUI_FontBauhaus9332_2215 } /* code 2215 */
  ,{  12,  12,  6, acGUI_FontBauhaus9332_2219 } /* code 2219 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_221A } /* code 221A */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_221E } /* code 221E */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_222B } /* code 222B */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2248 } /* code 2248 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2260 } /* code 2260 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2264 } /* code 2264 */
  ,{  15,  15,  8, acGUI_FontBauhaus9332_2265 } /* code 2265 */
  ,{  20,  20, 10, acGUI_FontBauhaus9332_25CA } /* code 25CA */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_F001 } /* code F001 */
  ,{  17,  17,  9, acGUI_FontBauhaus9332_F002 } /* code F002 */
  ,{   8,   8,  4, acGUI_FontBauhaus9332_FFFF } /* code FFFF */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop37 = {
   0xFFFF /* first character */
  ,0xFFFF /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[240] /* address of first character */
  ,(GUI_CONST_STORAGE GUI_FONT_PROP *)0 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop36 = {
   0xF001 /* first character */
  ,0xF002 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[238] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop37 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop35 = {
   0x25CA /* first character */
  ,0x25CA /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[237] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop36 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop34 = {
   0x2264 /* first character */
  ,0x2265 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[235] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop35 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop33 = {
   0x2260 /* first character */
  ,0x2260 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[234] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop34 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop32 = {
   0x2248 /* first character */
  ,0x2248 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[233] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop33 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop31 = {
   0x222B /* first character */
  ,0x222B /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[232] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop32 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop30 = {
   0x221E /* first character */
  ,0x221E /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[231] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop31 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop29 = {
   0x2219 /* first character */
  ,0x221A /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[229] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop30 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop28 = {
   0x2215 /* first character */
  ,0x2215 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[228] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop29 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop27 = {
   0x2211 /* first character */
  ,0x2211 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[227] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop28 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop26 = {
   0x220F /* first character */
  ,0x220F /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[226] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop27 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop25 = {
   0x2206 /* first character */
  ,0x2206 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[225] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop26 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop24 = {
   0x2202 /* first character */
  ,0x2202 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[224] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop25 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop23 = {
   0x2126 /* first character */
  ,0x2126 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[223] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop24 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop22 = {
   0x2122 /* first character */
  ,0x2122 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[222] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop23 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop21 = {
   0x20AC /* first character */
  ,0x20AC /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[221] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop22 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop20 = {
   0x2039 /* first character */
  ,0x203A /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[219] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop21 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop19 = {
   0x2030 /* first character */
  ,0x2030 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[218] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop20 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop18 = {
   0x2026 /* first character */
  ,0x2026 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[217] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop19 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop17 = {
   0x2020 /* first character */
  ,0x2022 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[214] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop18 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop16 = {
   0x201C /* first character */
  ,0x201E /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[211] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop17 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop15 = {
   0x2018 /* first character */
  ,0x201A /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[208] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop16 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop14 = {
   0x2013 /* first character */
  ,0x2014 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[206] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop15 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop13 = {
   0x03C0 /* first character */
  ,0x03C0 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[205] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop14 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop12 = {
   0x02D8 /* first character */
  ,0x02DD /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[199] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop13 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop11 = {
   0x02C9 /* first character */
  ,0x02C9 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[198] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop12 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop10 = {
   0x02C6 /* first character */
  ,0x02C7 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[196] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop11 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop9 = {
   0x0192 /* first character */
  ,0x0192 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[195] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop10 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop8 = {
   0x0178 /* first character */
  ,0x0178 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[194] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop9 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop7 = {
   0x0160 /* first character */
  ,0x0161 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[192] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop8 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop6 = {
   0x0152 /* first character */
  ,0x0153 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[190] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop7 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop5 = {
   0x0131 /* first character */
  ,0x0131 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[189] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop6 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop4 = {
   0x00B8 /* first character */
  ,0x00FF /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[117] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop5 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop3 = {
   0x00B0 /* first character */
  ,0x00B6 /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[110] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop4 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop2 = {
   0x00A0 /* first character */
  ,0x00AE /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[ 95] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop3 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT_PROP GUI_FontBauhaus9332_Prop1 = {
   0x0020 /* first character */
  ,0x007E /* last character  */
  ,&GUI_FontBauhaus9332_CharInfo[  0] /* address of first character */
  ,&GUI_FontBauhaus9332_Prop2 /* pointer to next GUI_FONT_PROP */
};

GUI_CONST_STORAGE GUI_FONT GUI_FontBauhaus9332 = {
   GUI_FONTTYPE_PROP_AA4 /* type of font    */
  ,32 /* height of font  */
  ,32 /* space of font y */
  ,1 /* magnification x */
  ,1 /* magnification y */
  ,{&GUI_FontBauhaus9332_Prop1}
  ,25 /* Baseline */
  ,14 /* Height of lowercase characters */
  ,19 /* Height of capital characters */
};

